## findlib 0.6.2

=== Makefile ===
# make all: compile to bytecode
# make opt: compile to native code
# make install: install bytecode and/or native code
#
# See Makefile.config for configurable variables.
# Runtime configurations might also be necessary in the site-lib/*/META
# files.
#----------------------------------------------------------------------

# To package findlib:
PREFIX =

NAME = findlib

OCAMLC = ocamlc
OCAMLOPT = ocamlopt
OCAMLDEP = ocamldep
OCAMLLEX = ocamllex
CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
#CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_dump.cmo --


OBJECTS        = findlib_config.cmo split.cmo metatoken.cmo meta.cmo \
		 metascanner.cmo topo.cmo
OBJECTS_NONMT  = metacache.cmo findlib.cmo
OBJECTS_MT     = metacache.cmo metacache_mt.cmo mt/findlib.cmo
TOBJECTS       = topfind.cmo
XOBJECTS       = findlib_config.cmx split.cmx metatoken.cmx meta.cmx \
		 metascanner.cmx topo.cmx
XOBJECTS_NONMT = metacache.cmx findlib.cmx
XOBJECTS_MT    = metacache.cmx metacache_mt.cmx mt/findlib.cmx

OCAMLFIND_OBJECTS = metacache_unix.cmo findlib_guess.cmo frontend.cmo
OCAMLFIND_XOBJECTS = metacache_unix.cmx findlib_guess.cmx frontend.cmx

all: ocamlfind$(EXEC_SUFFIX) findlib.cma findlib_mt.cma findlib_top.cma findlib.conf findlib

opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa findlib_mt.cmxa findlib.conf findlib

ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
	$(OCAMLC) -g -custom -o ocamlfind$(EXEC_SUFFIX) findlib.cma unix.cma \
	          $(OCAMLFIND_OBJECTS)

ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa  $(OCAMLFIND_XOBJECTS)
	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
		  $(OCAMLFIND_XOBJECTS)

findlib.cma: $(OBJECTS) $(OBJECTS_NONMT)
	$(OCAMLC) -a -o findlib.cma $(OBJECTS) $(OBJECTS_NONMT)

findlib_mt.cma: $(OBJECTS) $(OBJECTS_MT)
	$(OCAMLC) -a -o findlib_mt.cma $(OBJECTS) $(OBJECTS_MT)

findlib_top.cma: $(TOBJECTS)
	$(OCAMLC) -a -o findlib_top.cma $(TOBJECTS)

findlib.cmxa: $(XOBJECTS) $(XOBJECTS_NONMT)
	$(OCAMLOPT) -a -o findlib.cmxa $(XOBJECTS) $(XOBJECTS_NONMT)

findlib_mt.cmxa: $(XOBJECTS) $(XOBJECTS_MT)
	$(OCAMLOPT) -a -o findlib_mt.cmxa $(XOBJECTS) $(XOBJECTS_MT)

findlib_config.ml: findlib_config.mlp Makefile.config
	sed -e 's;@CONFIGFILE@;$(OCAMLFIND_CONF);g' \
	    -e 's;@STDLIB@;$(OCAML_CORE_STDLIB);g' \
	    -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
	    findlib_config.mlp >findlib_config.ml

findlib.conf: findlib.conf.in Makefile.config
	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
	    findlib.conf.in >findlib.conf

findlib: findlib.p
	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
	    findlib.p >findlib

findlib.ml: findlib.mlp
	sed -e 's:@METACACHE@:Metacache:g' \
	    findlib.mlp >findlib.ml

mt/findlib.mml: findlib.mlp
	mkdir -p mt
	sed -e 's:@METACACHE@:Metacache_mt:g' \
	    findlib.mlp >mt/findlib.mml

mt/findlib.cmo: findlib.cmo metacache_mt.cmo mt/findlib.cmi
mt/findlib.cmx: findlib.cmx metacache_mt.cmx mt/findlib.cmi
metacache_mt.cmo: metacache.cmo
metacache_mt.cmx: metacache.cmx

mt/findlib.cmi: findlib.cmi
	mkdir -p mt
	cp findlib.cmi findlib.mli mt

clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa findlib.ml findlib_mt.mml \
	  mt/*.* meta.ml findlib_config.ml findlib.mml findlib \
	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)


mrproper: clean
	rm -f metascanner.ml

# distclean: don't remove metascanner.ml; it is distributed

distclean: clean
	rm -f *~ mini/*~ findlib.conf
	cd config; rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa *~ testdb.* simple err.out makehelper withtk
	cd scripts; rm -f *~
	cd site-lib; for x in `ls`; do rm -f $$x/*~ $$x/META; done
	$(MAKE) -C doc distclean

RELEASE: META
	awk '/version/ { print substr($$3,2,length($$3)-2) }' META >RELEASE

dist: RELEASE
	test -f metascanner.ml
	r=`head -1 RELEASE`; cd ..; gtar czf $(NAME)-$$r.tar.gz --exclude='*/CVS*' --exclude="*/depend" --exclude="*/Makefile.config" --exclude="*/meta.ml" --exclude="*/findlib.ml" --exclude="*/mt/*" --exclude="*/dl/*" --exclude="*/dl" --exclude="*/dlgen/*" --exclude="*/dlgen" --exclude="*/Mail*" $(NAME)

tag-release: RELEASE
	r=`head -1 RELEASE | sed -e s/\\\./-/g`; cd ..; cvs tag -F $(NAME)-$$r $(NAME)

release: distclean
	$(MAKE) tag-release
	$(MAKE) dist

install: all
	mkdir -p $(PREFIX)$(OCAML_SITELIB)/$(NAME)
	mkdir -p $(PREFIX)$(OCAMLFIND_BIN)
	cp findlib $(PREFIX)$(OCAML_CORE_STDLIB)
	files=`./collect_files Makefile.config findlib.cmi findlib.mli findlib.cma findlib_mt.cma topfind.cmi topfind.mli findlib_top.cma findlib.cmxa findlib.a findlib_mt.cmxa findlib_mt.a META` && \
	cp $$files $(PREFIX)$(OCAML_SITELIB)/$(NAME)
	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
	cp $$f $(PREFIX)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)
	mkdir -p $(PREFIX)$(OCAMLFIND_MAN)/man1 $(PREFIX)$(OCAMLFIND_MAN)/man3 $(PREFIX)$(OCAMLFIND_MAN)/man5
	cp doc/man/ocamlfind.1 $(PREFIX)$(OCAMLFIND_MAN)/man1
	cp doc/man/Findlib.3 doc/man/Topfind.3 $(PREFIX)$(OCAMLFIND_MAN)/man3
	cp doc/man/META.5 doc/man/site-lib.5 doc/man/findlib.conf.5 $(PREFIX)$(OCAMLFIND_MAN)/man5
	$(MAKE) install-meta
	mkdir -p `dirname $(PREFIX)$(OCAMLFIND_CONF)`
	@if [ ! -f $(PREFIX)$(OCAMLFIND_CONF) ]; then echo "!!! Keeping old $(PREFIX)$(OCAMLFIND_CONF) !!!"; fi
	test -f $(PREFIX)$(OCAMLFIND_CONF) || cp findlib.conf $(PREFIX)$(OCAMLFIND_CONF)

install-meta:
	for x in `ls site-lib`; do if [ "$$x" != "CVS" -a -f "site-lib/$$x/META" ]; then mkdir -p $(PREFIX)$(OCAML_SITELIB)/$$x; cp site-lib/$$x/META $(PREFIX)$(OCAML_SITELIB)/$$x; fi; done


uninstall:
	$(MAKE) uninstall-meta
	rm -f $(PREFIX)$(OCAML_CORE_STDLIB)/findlib
	rm -rf $(PREFIX)$(OCAML_SITELIB)/$(NAME)
	rm -f $(PREFIX)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)
	rm -f $(PREFIX)$(OCAMLFIND_MAN)/man1/ocamlfind.1
	rm -f $(PREFIX)$(OCAMLFIND_MAN)/man3/Findlib.3
	rm -f $(PREFIX)$(OCAMLFIND_MAN)/man3/Topfind.3
	rm -f $(PREFIX)$(OCAMLFIND_MAN)/man5/META.5
	rm -f $(PREFIX)$(OCAMLFIND_MAN)/man5/site-lib.5

uninstall-meta:
	for x in `ls site-lib`; do if [ "$$x" != "CVS" ]; then rm -rf $(PREFIX)$(OCAML_SITELIB)/$$x; fi; done


depend: *.ml *.mli findlib.ml meta.ml metascanner.ml
	$(OCAMLDEP) *.ml *.mli >depend

Makefile.config:
	./configure

# Some 'make' implementations require that .SUFFIXES must occur before
# the first suffix rule. (E.g. AIX)
.SUFFIXES: .mll .cmo .cmi .cmx .ml .mli .mml .src

.mml.cmo:
	$(OCAMLC) -g -thread -c -impl $<

.mml.cmx:
	$(OCAMLOPT) -thread -c -impl $<

.ml.cmx:
	$(OCAMLOPT) -c $<

.ml.cmo:
	$(OCAMLC) -g -c $<

.mli.cmi:
	$(OCAMLC) -c $<

.src.ml:
	$(CAMLP4O) -impl $< -o $@

# Solaris make does not like the suffix rule .mll.ml,
# so I replaced it by its single application:
meta.ml: meta.mll
	$(OCAMLLEX) meta.mll

# Don't remove metascanner.ml:
.PRECIOUS: metascanner.ml

include Makefile.config
include depend

=== doc/Makefile ===
DOCBOOK_HTML = /usr/share/sgml/docbkdsl/html
DOCBOOK_PRINT = /usr/share/sgml/docbkdsl/print
SRC = $(PWD)/src

.PHONY: html tex man

default: html man QUICKSTART
# 'tex' still not working

html: html/book1.htm
tex: tex/findlib.dvi


html/book1.htm: src/*.sgml src/*.mod QUICKSTART.xml common.xml config.xml
	mkdir -p html
	cd html; \
	rm -f *.htm*; \
	jade -t sgml -D$(DOCBOOK_HTML) -D$(SRC) findlib.sgml; \
	true
	readme -html QUICKSTART.xml >html/quickstart.html
	touch html/TIMESTAMP

man: src/findlib_reference.xml
	mkdir -p man
	cd man; \
	rm -f *.[0-9]; \
	db2man <../src/findlib_reference.xml

tex/findlib.tex: src/*.sgml src/*.mod
	mkdir -p tex
	cd tex;
	jade -t tex -D$(DOCBOOK_PRINT) -D$(SRC) findlib.sgml; \
	true

tex/findlib.dvi: tex/findlib.tex
	cd tex;
	jadetex findlib.tex

.SUFFIXES: .xml .sgml

.sgml.xml: 
	sx -xndata $< >$@; true



clean:
	rm -rf html man tex
	rm -f src/*.xml

distclean:
	rm -f src/*.xml
	rm -f src/*~
	rm -f *~

QUICKSTART: QUICKSTART.xml
	readme -text QUICKSTART.xml >QUICKSTART

## findlib 1.0.4

=== Makefile ===
# make all: compile to bytecode
# make opt: compile to native code
# make install: install bytecode and/or native code
#----------------------------------------------------------------------

include Makefile.config

TOP=.

.PHONY: all opt install uninstall clean

all:
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) all ); done
	$(MAKE) all-config

opt:
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) opt ); done

install:
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) install ); done
	$(MAKE) install-doc
	$(MAKE) install-meta
	cd src/findlib; $(MAKE) install-num-top
	$(MAKE) install-config

uninstall:
	$(MAKE) uninstall-doc
	$(MAKE) uninstall-meta
	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) uninstall ); done
	$(MAKE) uninstall-config

clean:
	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) clean ); done
	(cd itest-aux; $(MAKE) clean)
	rm -f findlib.conf

.PHONY: release
release: README
	./release

README: doc/README
	ln -s doc/README .


.PHONY: all-config
all-config: findlib.conf

findlib.conf: findlib.conf.in 
	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
	    findlib.conf.in >findlib.conf

.PHONY: install-doc
install-doc:
	mkdir -p $(prefix)$(OCAMLFIND_MAN)/man1 $(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5
	cp doc/ref-man/ocamlfind.1 $(prefix)$(OCAMLFIND_MAN)/man1
	cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 $(prefix)$(OCAMLFIND_MAN)/man5

.PHONY: uninstall-doc
uninstall-doc:
	rm -f $(prefix)$(OCAMLFIND_MAN)/man1/ocamlfind.1
	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Findlib.3
	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Topfind.3
	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/META.5
	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/site-lib.5


.PHONY: install-meta
install-meta:
	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" -a -f "site-lib-src/$$x/META" ]; then mkdir -p $(prefix)$(OCAML_SITELIB)/$$x; cp site-lib-src/$$x/META $(prefix)$(OCAML_SITELIB)/$$x; fi; done

.PHONY: uninstall-meta
uninstall-meta:
	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" ]; then rm -rf $(prefix)$(OCAML_SITELIB)/$$x; fi; done

.PHONY: install-config
install-config:
	mkdir -p `dirname $(prefix)$(OCAMLFIND_CONF)`
	@if [ -f $(prefix)$(OCAMLFIND_CONF) ]; then echo "!!! Keeping old $(prefix)$(OCAMLFIND_CONF) !!!"; fi
	test -f $(prefix)$(OCAMLFIND_CONF) || cp findlib.conf $(prefix)$(OCAMLFIND_CONF)

.PHONY: uninstall-config
uninstall-config:
	@echo Leaving $(OCAMLFIND_CONF) installed, consider manual removal

.PHONY: interface-lists
interface-lists:
	d=`ocamlc -where`;                              \
	for x in `ls site-lib-src`; do                  \
	    iflist="";                                  \
            if [ ! -f "site-lib-src/$$x/interfaces.in" ]; then continue; fi; \
	    cma_spec=`cat site-lib-src/$$x/interfaces.in`;  \
	    for cma in $$d/$$cma_spec; do               \
		intf=`objinfo $$cma |                   \
		      grep 'Unit name:' |               \
		      sed -e 's/^  Unit name: //' |     \
		      sort |                            \
		      tr '\n' ' '`;                     \
		iflist="$$iflist $$intf";               \
	    done;                                       \
	    echo "$$iflist" >"site-lib-src/$$x/interfaces.out"; \
	done

=== src/findlib/Makefile ===
# make all: compile to bytecode
# make opt: compile to native code
# make install: install bytecode and/or native code
#
# See Makefile.config for configurable variables.
# Runtime configurations might also be necessary in the site-lib/*/META
# files.
#----------------------------------------------------------------------

TOP=../..

NAME = findlib

OCAMLC = ocamlc
OCAMLOPT = ocamlopt
OCAMLDEP = ocamldep
OCAMLLEX = ocamllex
CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
#CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_dump.cmo --


OBJECTS        = findlib_config.cmo fl_split.cmo fl_metatoken.cmo fl_meta.cmo \
		 fl_metascanner.cmo fl_topo.cmo fl_package_base.cmo \
	         findlib.cmo
TOBJECTS       = topfind.cmo

XOBJECTS       = $(OBJECTS:.cmo=.cmx)

OCAMLFIND_OBJECTS = frontend.cmo
OCAMLFIND_XOBJECTS = frontend.cmx

NUMTOP_OBJECTS = num_top_printers.cmo num_top.cmo

all: ocamlfind$(EXEC_SUFFIX) findlib.cma findlib_top.cma topfind num_top.cma

opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa topfind

ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
	$(OCAMLC) -custom -o ocamlfind$(EXEC_SUFFIX) findlib.cma unix.cma \
	          $(OCAMLFIND_OBJECTS)

ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa $(OCAMLFIND_XOBJECTS)
	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
		  $(OCAMLFIND_XOBJECTS)

findlib.cma: $(OBJECTS)
	$(OCAMLC) -a -o findlib.cma $(OBJECTS)

findlib_top.cma: $(TOBJECTS)
	$(OCAMLC) -a -o findlib_top.cma $(TOBJECTS)

findlib.cmxa: $(XOBJECTS)
	$(OCAMLOPT) -a -o findlib.cmxa $(XOBJECTS)

findlib_config.ml: findlib_config.mlp 
	sed -e 's;@CONFIGFILE@;$(OCAMLFIND_CONF);g' \
	    -e 's;@STDLIB@;$(OCAML_CORE_STDLIB);g' \
	    -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
	    findlib_config.mlp >findlib_config.ml

topfind: topfind.p
	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
	    topfind.p >topfind

num_top.cma: $(NUMTOP_OBJECTS)
	$(OCAMLC) -a -o num_top.cma $(NUMTOP_OBJECTS)

clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa \
	  fl_meta.ml findlib_config.ml findlib.mml topfind \
	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)

install: all
	mkdir -p $(prefix)$(OCAML_SITELIB)/$(NAME)
	mkdir -p $(prefix)$(OCAMLFIND_BIN)
	test $(INSTALL_TOPFIND) -eq 0 || cp topfind $(prefix)$(OCAML_CORE_STDLIB)
	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi findlib_top.cma findlib.cmxa findlib.a META` && \
	cp $$files $(prefix)$(OCAML_SITELIB)/$(NAME)
	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
	cp $$f $(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)

install-num-top:
	mkdir -p $(prefix)$(OCAML_SITELIB)/num-top
	cp num_top.cma num_top.cmi num_top_printers.cmi \
		$(prefix)$(OCAML_SITELIB)/num-top

# Note: uninstall-num-top is part of the removal of the META files.

uninstall:
	rm -f $(prefix)$(OCAML_CORE_STDLIB)/findlib
	rm -rf $(prefix)$(OCAML_SITELIB)/$(NAME)
	rm -f $(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)


depend: *.ml *.mli fl_meta.ml fl_metascanner.ml
	$(OCAMLDEP) *.ml *.mli >depend

# Some 'make' implementations require that .SUFFIXES must occur before
# the first suffix rule. (E.g. AIX)
.SUFFIXES: .mll .cmo .cmi .cmx .ml .mli .mml .src

.mml.cmo:
	$(OCAMLC) -g -vmthread -c -impl $<

.mml.cmx:
	$(OCAMLOPT) -thread -c -impl $<

.ml.cmx:
	$(OCAMLOPT) -c $<

.ml.cmo:
	$(OCAMLC) -g -c $<

.mli.cmi:
	$(OCAMLC) -c $<

.src.ml:
	$(CAMLP4O) -impl $< -o $@

# Solaris make does not like the suffix rule .mll.ml,
# so I replaced it by its single application:
fl_meta.ml: fl_meta.mll
	$(OCAMLLEX) fl_meta.mll

# Don't remove fl_metascanner.ml:
.PRECIOUS: fl_metascanner.ml

include $(TOP)/Makefile.config
include depend

## findlib 1.1.1

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 clean:
 	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) clean ); done
 	(cd itest-aux; $(MAKE) clean)
+	(cd tools/extract_args; $(MAKE) clean)
 	rm -f findlib.conf
 
 .PHONY: release
@@ -48,6 +49,15 @@
 findlib.conf: findlib.conf.in 
 	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
 	    findlib.conf.in >findlib.conf
+	if ocamlc.opt >/dev/null 2>&1; then \
+		echo 'ocamlc="ocamlc.opt"' >>findlib.conf; \
+	fi
+	if ocamlopt.opt >/dev/null 2>&1; then \
+		echo 'ocamlopt="ocamlopt.opt"' >>findlib.conf; \
+	fi
+	if ocamldep.opt >/dev/null 2>&1; then \
+		echo 'ocamldep="ocamldep.opt"' >>findlib.conf; \
+	fi
 
 .PHONY: install-doc
 install-doc:

## findlib 1.1.2pl1

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,7 @@
 	$(MAKE) install-meta
 	cd src/findlib; $(MAKE) install-num-top
 	$(MAKE) install-config
+	cp tools/safe_camlp4 $(OCAMLFIND_BIN)
 
 uninstall:
 	$(MAKE) uninstall-doc

## findlib 1.2.1

=== Makefile ===
--- 
+++ 
@@ -17,12 +17,14 @@
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) opt ); done
 
 install:
+	mkdir -p $(prefix)$(OCAMLFIND_BIN)
+	mkdir -p $(prefix)$(OCAMLFIND_MAN)
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) install ); done
-	$(MAKE) install-doc
 	$(MAKE) install-meta
 	cd src/findlib; $(MAKE) install-num-top
 	$(MAKE) install-config
-	cp tools/safe_camlp4 $(OCAMLFIND_BIN)
+	cp tools/safe_camlp4 $(prefix)$(OCAMLFIND_BIN)
+	$(MAKE) install-doc
 
 uninstall:
 	$(MAKE) uninstall-doc
@@ -48,8 +50,10 @@
 all-config: findlib.conf
 
 findlib.conf: findlib.conf.in 
-	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
-	    findlib.conf.in >findlib.conf
+	USE_CYGPATH="$(USE_CYGPATH)"; \
+	export USE_CYGPATH; \
+	cat findlib.conf.in | \
+		tools/patch '@SITELIB@' '$(OCAML_SITELIB)' >findlib.conf
 	if ocamlc.opt >/dev/null 2>&1; then \
 		echo 'ocamlc="ocamlc.opt"' >>findlib.conf; \
 	fi
@@ -111,3 +115,16 @@
 	    echo "$$iflist" >"site-lib-src/$$x/interfaces.out"; \
 	done
 
+######################################################################
+# The following is from Pietro Abata <pietro.abate@anu.edu.au>
+# to create MacOS X packages. I did not test it, just include it.
+
+.PHONY: package-macosx
+
+package-macosx: all opt
+	mkdir -p package-macosx/root
+	export prefix=`pwd`/package-macosx/root && make install 
+	export VERSION=1.1.2 && tools/make-package-macosx
+
+clean-macosx:
+	sudo rm -rf package-macosx

=== src/findlib/Makefile ===
--- 
+++ 
@@ -26,8 +26,8 @@
 
 XOBJECTS       = $(OBJECTS:.cmo=.cmx)
 
-OCAMLFIND_OBJECTS = frontend.cmo
-OCAMLFIND_XOBJECTS = frontend.cmx
+OCAMLFIND_OBJECTS = ocaml_args.cmo frontend.cmo
+OCAMLFIND_XOBJECTS = ocaml_args.cmx frontend.cmx
 
 NUMTOP_OBJECTS = num_top_printers.cmo num_top.cmo
 
@@ -53,14 +53,21 @@
 	$(OCAMLOPT) -a -o findlib.cmxa $(XOBJECTS)
 
 findlib_config.ml: findlib_config.mlp 
-	sed -e 's;@CONFIGFILE@;$(OCAMLFIND_CONF);g' \
-	    -e 's;@STDLIB@;$(OCAML_CORE_STDLIB);g' \
-	    -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
-	    findlib_config.mlp >findlib_config.ml
+	USE_CYGPATH="$(USE_CYGPATH)"; \
+	export USE_CYGPATH; \
+	cat findlib_config.mlp | \
+		$(TOP)/tools/patch '@CONFIGFILE@' '$(OCAMLFIND_CONF)' | \
+		$(TOP)/tools/patch '@STDLIB@' '$(OCAML_CORE_STDLIB)' | \
+		sed -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
+		    -e 's;@SYSTEM@;$(SYSTEM);g' \
+		     >findlib_config.ml
 
 topfind: topfind.p
-	sed -e 's;@SITELIB@;$(OCAML_SITELIB);g' \
-	    topfind.p >topfind
+	USE_CYGPATH="$(USE_CYGPATH)"; \
+	export USE_CYGPATH; \
+	cat topfind.p | \
+		$(TOP)/tools/patch '@SITELIB@' '$(OCAML_SITELIB)' \
+	    	    >topfind
 
 num_top.cma: $(NUMTOP_OBJECTS)
 	$(OCAMLC) -a -o num_top.cma $(NUMTOP_OBJECTS)

## findlib 1.2.4

=== src/findlib/Makefile ===
--- 
+++ 
@@ -78,18 +78,18 @@
 	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)
 
 install: all
-	mkdir -p $(prefix)$(OCAML_SITELIB)/$(NAME)
-	mkdir -p $(prefix)$(OCAMLFIND_BIN)
-	test $(INSTALL_TOPFIND) -eq 0 || cp topfind $(prefix)$(OCAML_CORE_STDLIB)
+	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
+	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
+	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
 	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi findlib_top.cma findlib.cmxa findlib.a META` && \
-	cp $$files $(prefix)$(OCAML_SITELIB)/$(NAME)
+	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
-	cp $$f $(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)
+	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
 
 install-num-top:
-	mkdir -p $(prefix)$(OCAML_SITELIB)/num-top
+	mkdir -p "$(prefix)$(OCAML_SITELIB)/num-top"
 	cp num_top.cma num_top.cmi num_top_printers.cmi \
-		$(prefix)$(OCAML_SITELIB)/num-top
+		"$(prefix)$(OCAML_SITELIB)/num-top"
 
 # Note: uninstall-num-top is part of the removal of the META files.

## findlib 1.2.7+debian

=== Makefile ===
--- 
+++ 
@@ -17,13 +17,13 @@
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) opt ); done
 
 install:
-	mkdir -p $(prefix)$(OCAMLFIND_BIN)
-	mkdir -p $(prefix)$(OCAMLFIND_MAN)
+	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
+	mkdir -p "$(prefix)$(OCAMLFIND_MAN)"
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) install ); done
 	$(MAKE) install-meta
 	cd src/findlib; $(MAKE) install-num-top
 	$(MAKE) install-config
-	cp tools/safe_camlp4 $(prefix)$(OCAMLFIND_BIN)
+	cp tools/safe_camlp4 "$(prefix)$(OCAMLFIND_BIN)"
 	$(MAKE) install-doc
 
 uninstall:
@@ -67,8 +67,8 @@
 .PHONY: install-doc
 install-doc:
 	mkdir -p $(prefix)$(OCAMLFIND_MAN)/man1 $(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5
-	cp doc/ref-man/ocamlfind.1 $(prefix)$(OCAMLFIND_MAN)/man1
-	cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 $(prefix)$(OCAMLFIND_MAN)/man5
+	-cp doc/ref-man/ocamlfind.1 $(prefix)$(OCAMLFIND_MAN)/man1
+	-cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 $(prefix)$(OCAMLFIND_MAN)/man5
 
 .PHONY: uninstall-doc
 uninstall-doc:
@@ -81,21 +81,21 @@
 
 .PHONY: install-meta
 install-meta:
-	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" -a -f "site-lib-src/$$x/META" ]; then mkdir -p $(prefix)$(OCAML_SITELIB)/$$x; cp site-lib-src/$$x/META $(prefix)$(OCAML_SITELIB)/$$x; fi; done
+	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" -a -f "site-lib-src/$$x/META" ]; then mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
 
 .PHONY: uninstall-meta
 uninstall-meta:
-	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" ]; then rm -rf $(prefix)$(OCAML_SITELIB)/$$x; fi; done
+	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" ]; then rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
 
 .PHONY: install-config
 install-config:
-	mkdir -p `dirname $(prefix)$(OCAMLFIND_CONF)`
-	@if [ -f $(prefix)$(OCAMLFIND_CONF) ]; then echo "!!! Keeping old $(prefix)$(OCAMLFIND_CONF) !!!"; fi
-	test -f $(prefix)$(OCAMLFIND_CONF) || cp findlib.conf $(prefix)$(OCAMLFIND_CONF)
+	mkdir -p "`dirname \"$(prefix)$(OCAMLFIND_CONF)\"`"
+	@if [ -f "$(prefix)$(OCAMLFIND_CONF)" ]; then echo "!!! Keeping old $(prefix)$(OCAMLFIND_CONF) !!!"; fi
+	test -f "$(prefix)$(OCAMLFIND_CONF)" || cp findlib.conf "$(prefix)$(OCAMLFIND_CONF)"
 
 .PHONY: uninstall-config
 uninstall-config:
-	@echo Leaving $(OCAMLFIND_CONF) installed, consider manual removal
+	@echo Leaving "$(OCAMLFIND_CONF)" installed, consider manual removal
 
 .PHONY: interface-lists
 interface-lists:

=== debian/changelog ===
findlib (1.2.7+debian-1build3) precise; urgency=low

  * Rebuild to know about ocamlopt on armhf.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 23 Jan 2012 18:14:27 +0000

findlib (1.2.7+debian-1build2) precise; urgency=low

  * Rebuild for OCaml 3.12.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Nov 2011 20:51:45 +0000

findlib (1.2.7+debian-1build1) oneiric; urgency=low

  * Rebuild to pick up armel ocaml fixes.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 19 Aug 2011 13:15:30 -0600

findlib (1.2.7+debian-1) unstable; urgency=low

  * New upstream release
  * Add myself to Uploaders
  * Add patches:
    - Make Camlp4 depend on Dynlink on every arch (Closes: #630490)
    - Use a relative path in META.camlp4 (Closes: #628021)
    - Disable graphics and labltk when unavailable (Closes: #605695)

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Mon, 27 Jun 2011 22:45:07 +0200

findlib (1.2.6+debian-2) unstable; urgency=low

  * Updated 0002-Extra-configuration-search-path.patch
    to allow overriding Debian-specific configuration 
    variables in findlib's main configuration.
    This issue appear when using for instance mingw32-ocaml
    where the main configuration file changed but Debian-specific
    settings override it.

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 04 Apr 2011 20:06:47 -0500

findlib (1.2.6+debian-1) unstable; urgency=low

  * New upstream release
  * Make ocaml-findlib depend only on libfindlib-ocaml
  * Switch source package format to 3.0 (quilt)
  * Rewrite debian/rules using dh with overrides
  * Bump Standards-Version to 3.9.1
  * Bump debhelper compat level to 8
  * Remove Stefano from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Sat, 12 Feb 2011 12:04:41 +0100

findlib (1.2.5+debian-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * New upstream release:
    - remove install_missing_cmi.dpatch (merged upstream)
    - repackage upstream with documentation sources:
      + add explanations to README.source
      + take it into account in debian/watch
  * Add new binary packages:
    - ocaml-findlib: keep there executables not depending on X
    - ocaml-findlib-wizard: make_wizard (which depends on X)
    - libfindlib-ocaml{,-dev}: the remaining files, dispatched as usual
  * debian/control:
    - build-depends on ocaml-nox (>= 3.11.1-3~)
    - update e-mail addresses
    - move to section ocaml
    - update Standards-Version to 3.8.3
  * Update debian/copyright

  [ Mehdi Dogguy ]
  * Add myself to uploaders
  * Use dh_ocaml in the build process
    - Modify debian/control accordingly
  * Build-depend on dh-ocaml 0.9

 -- Stéphane Glondu <glondu@debian.org>  Sat, 26 Sep 2009 10:14:54 +0200

findlib (1.2.4-2) unstable; urgency=low

  * add back "directory" directive to site_lib_metas patch, fixes FTBFS of
    reverse dependent packages which need the "num" findlib package
    (revert "simplify site_lib_metas" change in -1)

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 28 Feb 2009 23:33:44 +0100

findlib (1.2.4-1) unstable; urgency=low

  [ Stephane Glondu ]
  * New Upstream Version
  * Update patches:
    - remove natdynlink (merged upstream)
    - simplify site_lib_metas
    - update install_missing_cmi
  * Remove versioned dependencies on ocaml
  * Bump debhelper compatibility to 7 (no changes)

  [ Stefano Zacchiroli ]
  * uploading to unstable
    - bump ocaml build-dep to (>= 3.11) to entail proper dep-waits
  * debian/rules: invoke ocaml.mk as a "rules" snippet
  * debian/control: version build-dep on dh-ocaml to 0.4.1 (to avoid the
    "remove heading white spaces" bug for debian/patches/*.in)
  * debian/svn-deblayout: remove no longer needed SVN setting
  * debian/source.lintian-overrides: fix typo in the tag name (which
    inhibited the override to work)

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 24 Feb 2009 13:54:26 +0100

findlib (1.2.3-1) experimental; urgency=low

  * New Upstream Version
  * Add README.source
  * Update Standards-Version to 3.8.0
  * Add myself to Uploaders
  * Update versioned dependencies to OCaml

 -- Stephane Glondu <steph@glondu.net>  Fri, 05 Dec 2008 19:59:13 +0100

findlib (1.2.1-6) experimental; urgency=low

  [ Stefano Zacchiroli ]
  * make Vcs-* fields point to the new git repository

  [ Stephane Glondu ]
  * Add natdynlink.dpatch, to add dynlink.cmxa to META.dynlink, if
    available.

  [ Romain Beauxis ]
  * Added build-dep on dh-ocaml
  * Upload and build against ocaml 3.11 in experimental
  * Versioned ocaml-related build-dep to avoid confusion 

 -- Romain Beauxis <toots@rastageeks.org>  Fri, 28 Nov 2008 01:08:26 +0100

findlib (1.2.1-5) unstable; urgency=low

  [ Stephane Glondu ]
  * Update Homepage, fix watch file.

  [ Ralf Treinen ]
  * Changed doc-base section to Programming/OCaml

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 04 Jun 2008 13:55:33 +0200

findlib (1.2.1-4.1) experimental; urgency=low

  * Rebuild with ocaml 3.10.2, NMU to experimental with maintainer's blessing.
  * Install docs into section Programming instead of Apps/Programming.

 -- Ralf Treinen <treinen@debian.org>  Sat, 22 Mar 2008 20:23:22 +0100

findlib (1.2.1-4) unstable; urgency=low

  * fix vcs-svn field to point just above the debian/ dir
  * reword long description, also mentioning "ocamlfind" (Closes: #460669)
  * bump build dep to ocaml 3.10.1

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 09 Feb 2008 17:31:24 +0100

findlib (1.2.1-3) unstable; urgency=low

  * update standards-version, no changes needed
  * setting me as an uploader, d-o-m as the maintainer
  * avoid installing empty /usr/share/ocaml-findlib/, it will be created by
    packages shipping stuff there (fixes lintian warning)
  * avoid installing empty /usr/share/man/man3/ (fixes lintian warning)
  * add lintian override for missing stddirs.dpatch patch in 00list; the patch
    is automatically generated from stddirs.dpatch.in
  * debian/patches/install_missing_cmi.dpatch: new patch to install some


=== debian/control ===
Source: findlib
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox (>= 3.11.1-3~),
 ocaml,
 camlp4,
 m4,
 gawk | awk,
 dh-ocaml (>= 0.9~)
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/findlib.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/findlib.git
Homepage: http://projects.camlcity.org/projects/findlib.html

Package: ocaml-findlib
Architecture: any
Depends:
 libfindlib-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 camlp4,
 ocaml-findlib-wizard
Recommends: libfindlib-ocaml-dev
Provides: ${ocaml:Provides}
Description: management tool for OCaml libraries
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains a tool (ocamlfind) that allows the user to
 enter queries on the command-line. In order to simplify compilation
 and linkage, there are new frontends, all driven by ocamlfind, for
 the various OCaml compilers that can directly deal with packages.

Package: libfindlib-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: ocaml-findlib
Provides: ${ocaml:Provides}
Replaces: ocaml-findlib (<< 1.2.4-3)
Breaks: ocaml-findlib (<< 1.2.4-3)
Description: library for managing OCaml libraries (development files)
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains development files needed to compile programs
 using findlib.

Package: libfindlib-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces: ocaml-findlib (<< 1.2.4-3)
Breaks: ocaml-findlib (<< 1.2.4-3)
Description: library for managing OCaml libraries (runtime)
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains files that are or may be needed at runtime by
 programs using findlib (META files and dynamically-loadable files).

Package: ocaml-findlib-wizard
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces: ocaml-findlib (<< 1.2.4-3)
Breaks: ocaml-findlib (<< 1.2.4-3)
Description: Makefile and META wizard for OCaml libraries
 This wizard helps you creating Makefiles and META files for simple
 OCaml library projects. It generates a Makefile, and the Makefile
 produces the META file. This generated build system is a starting
 point and can be later fine-tuned.

## findlib 1.2.8+debian

=== debian/changelog ===
findlib (1.2.8+debian-1) unstable; urgency=low

  * New upstream release
  * Switch debian/copyright to format 1.0
  * Bump Standards-Version to 3.9.3

 -- Stéphane Glondu <glondu@debian.org>  Tue, 28 Feb 2012 08:50:01 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  m4,
  gawk | awk,
  dh-ocaml (>= 0.9~)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/findlib.git
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/findlib.git
 Homepage: http://projects.camlcity.org/projects/findlib.html

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure \
		-config /etc/ocamlfind.conf \
		-bindir /usr/bin \
		-sitelib $(OCAML_STDLIB_DIR) \
		-mandir /usr/share/man \
		-with-toolbox

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE)
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) opt
endif

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install prefix=$(CURDIR)/debian/tmp
# rm ocamlc.opt and similar settings, they're not avail everywhere in debian
	grep -v \\.opt debian/tmp/etc/ocamlfind.conf > debian/ocamlfind.conf.new
	sed -i -e 's/@OCamlABI@/$(OCAML_ABI)/g' debian/ocamlfind.conf.new
	mv debian/ocamlfind.conf.new debian/tmp/etc/ocamlfind.conf
# mv METAs from empty directories to the /META directory
	mkdir -p $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS
	for p in `ls site-lib-src/`; do \
	  mv $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/META \
	    $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS/META.$$p; \
	  rmdir $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/; \
	done
# rm empty man3 dir
	test -d $(CURDIR)/debian/tmp/usr/share/man/man3 && \
		rmdir $(CURDIR)/debian/tmp/usr/share/man/man3

# do not strip executables on bytecode executables (is this still needed?)
ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
.PHONY: override_dh_strip
override_dh_strip:
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	if [ -f Makefile.config ]; then $(MAKE) clean; fi
	ln -sf doc/README README
	-find . -name META -delete
	-rm -f src/findlib/depend src/findlib/fl_metascanner.ml
	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
	-rm -Rf site-lib-src/camlp4/

## findlib 1.3.1

=== src/findlib/Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 OBJECTS        = findlib_config.cmo fl_split.cmo fl_metatoken.cmo fl_meta.cmo \
 		 fl_metascanner.cmo fl_topo.cmo fl_package_base.cmo \
-	         findlib.cmo
+	         findlib.cmo fl_args.cmo
 TOBJECTS       = topfind.cmo
 
 XOBJECTS       = $(OBJECTS:.cmo=.cmx)
@@ -37,11 +37,11 @@
 
 ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
 	$(OCAMLC) -custom -o ocamlfind$(EXEC_SUFFIX) findlib.cma unix.cma \
-	          $(OCAMLFIND_OBJECTS)
+	          $(OCAMLC_FLAGS) $(OCAMLFIND_OBJECTS)
 
 ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa $(OCAMLFIND_XOBJECTS)
 	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
-		  $(OCAMLFIND_XOBJECTS)
+		  $(OCAMLOPT_FLAGS) $(OCAMLFIND_XOBJECTS)
 
 findlib.cma: $(OBJECTS)
 	$(OCAMLC) -a -o findlib.cma $(OBJECTS)
@@ -52,7 +52,7 @@
 findlib.cmxa: $(XOBJECTS)
 	$(OCAMLOPT) -a -o findlib.cmxa $(XOBJECTS)
 
-findlib_config.ml: findlib_config.mlp 
+findlib_config.ml: findlib_config.mlp $(TOP)/Makefile.config
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
 	cat findlib_config.mlp | \
@@ -81,7 +81,7 @@
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
 	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
-	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi findlib_top.cma findlib.cmxa findlib.a META` && \
+	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib.cmxa findlib.a META` && \
 	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
 	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"

=== debian/changelog ===
findlib (1.3.1-1) unstable; urgency=low

  * New upstream release
    - documentation sources are now included in the official upstream
      tarball, repackaging is no longer needed
  * Update debian/copyright

 -- Stéphane Glondu <glondu@debian.org>  Tue, 05 Jun 2012 11:24:23 +0200

=== debian/rules ===
--- 
+++ 
@@ -52,7 +52,6 @@
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
 	if [ -f Makefile.config ]; then $(MAKE) clean; fi
-	ln -sf doc/README README
 	-find . -name META -delete
 	-rm -f src/findlib/depend src/findlib/fl_metascanner.ml
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml

## findlib 1.4

=== Makefile ===
--- 
+++ 
@@ -63,6 +63,9 @@
 	if ocamldep.opt >/dev/null 2>&1; then \
 		echo 'ocamldep="ocamldep.opt"' >>findlib.conf; \
 	fi
+	if ocamldoc.opt >/dev/null 2>&1; then \
+		echo 'ocamldoc="ocamldoc.opt"' >>findlib.conf; \
+	fi
 
 .PHONY: install-doc
 install-doc:
@@ -105,7 +108,7 @@
             if [ ! -f "site-lib-src/$$x/interfaces.in" ]; then continue; fi; \
 	    cma_spec=`cat site-lib-src/$$x/interfaces.in`;  \
 	    for cma in $$d/$$cma_spec; do               \
-		intf=`objinfo $$cma |                   \
+		intf=`ocamlobjinfo $$cma |                   \
 		      grep 'Unit name:' |               \
 		      sed -e 's/^  Unit name: //' |     \
 		      sort |                            \

=== src/findlib/Makefile ===
--- 
+++ 
@@ -8,14 +8,16 @@
 #----------------------------------------------------------------------
 
 TOP=../..
+include $(TOP)/Makefile.config
 
 NAME = findlib
 
-OCAMLC = ocamlc
-OCAMLOPT = ocamlopt
+# Need compiler-libs since ocaml-4.00
+OCAMLC = ocamlc -I +compiler-libs
+OCAMLOPT = ocamlopt -I +compiler-libs
 OCAMLDEP = ocamldep
 OCAMLLEX = ocamllex
-CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
+#CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
 #CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_dump.cmo --
 
 
@@ -36,12 +38,15 @@
 opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa topfind
 
 ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
-	$(OCAMLC) -custom -o ocamlfind$(EXEC_SUFFIX) findlib.cma unix.cma \
+	$(OCAMLC) $(CUSTOM) -o ocamlfind$(EXEC_SUFFIX) -g findlib.cma unix.cma \
 	          $(OCAMLC_FLAGS) $(OCAMLFIND_OBJECTS)
 
 ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa $(OCAMLFIND_XOBJECTS)
 	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
 		  $(OCAMLOPT_FLAGS) $(OCAMLFIND_XOBJECTS)
+
+test_parser$(EXEC_SUFFIX): fl_metascanner.cmx test_parser.cmx fl_metatoken.cmx fl_meta.cmx
+	$(OCAMLOPT) -o test_parser$(EXEC_SUFFIX) fl_meta.cmx fl_metatoken.cmx fl_metascanner.cmx test_parser.cmx
 
 findlib.cma: $(OBJECTS)
 	$(OCAMLC) -a -o findlib.cma $(OBJECTS)
@@ -62,10 +67,10 @@
 		    -e 's;@SYSTEM@;$(SYSTEM);g' \
 		     >findlib_config.ml
 
-topfind: topfind.p
+topfind: topfind_rd$(OCAML_REMOVE_DIRECTORY).p
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
-	cat topfind.p | \
+	cat topfind_rd$(OCAML_REMOVE_DIRECTORY).p | \
 		$(TOP)/tools/patch '@SITELIB@' '$(OCAML_SITELIB)' \
 	    	    >topfind
 
@@ -76,6 +81,7 @@
 	rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa \
 	  fl_meta.ml findlib_config.ml findlib.mml topfind \
 	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)
+	#rm -f ocaml_args.ml
 
 install: all
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
@@ -85,6 +91,11 @@
 	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
 	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
+	# the following "if" block is only needed for 4.00beta2
+	if [ $(OCAML_REMOVE_DIRECTORY) -eq 0 -a -f "$(OCAML_CORE_STDLIB)/compiler-libs/topdirs.cmi" ]; then \
+	    cd "$(OCAML_CORE_STDLIB)/compiler-libs/"; \
+	    cp topdirs.cmi toploop.cmi "$(prefix)$(OCAML_SITELIB)/$(NAME)/"; \
+	fi
 
 install-num-top:
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/num-top"
@@ -104,7 +115,8 @@
 
 # Some 'make' implementations require that .SUFFIXES must occur before
 # the first suffix rule. (E.g. AIX)
-.SUFFIXES: .mll .cmo .cmi .cmx .ml .mli .mml .src
+.SUFFIXES: .mll .cmo .cmi .cmx .ml .mli .mml 
+# .src
 
 .mml.cmo:
 	$(OCAMLC) -g -vmthread -c -impl $<
@@ -121,8 +133,8 @@
 .mli.cmi:
 	$(OCAMLC) -c $<
 
-.src.ml:
-	$(CAMLP4O) -impl $< -o $@
+#.src.ml:
+#	$(CAMLP4O) -impl $< -o $@
 
 # Solaris make does not like the suffix rule .mll.ml,
 # so I replaced it by its single application:
@@ -132,6 +144,5 @@
 # Don't remove fl_metascanner.ml:
 .PRECIOUS: fl_metascanner.ml
 
-include $(TOP)/Makefile.config
 include depend

=== debian/changelog ===
findlib (1.4-2) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Dec 2013 21:34:58 +0100

findlib (1.4-1) experimental; urgency=low

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.4

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Jul 2013 11:46:23 +0200

findlib (1.3.3-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 25 Nov 2012 14:38:51 +0100

findlib (1.3.2-1) experimental; urgency=low

  * New upstream release
    - incompatible with 3.x versions of OCaml shipped by Debian

 -- Stéphane Glondu <glondu@debian.org>  Thu, 21 Jun 2012 19:18:38 +0200

=== debian/control ===
--- 
+++ 
@@ -8,15 +8,15 @@
  Nicolas Dandrimont <nicolas.dandrimont@crans.org>
 Build-Depends:
  debhelper (>= 8),
- ocaml-nox (>= 3.11.1-3~),
+ ocaml-nox (>= 4.00.0~beta),
  ocaml,
  camlp4,
  m4,
  gawk | awk,
  dh-ocaml (>= 0.9~)
-Standards-Version: 3.9.3
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/findlib.git
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/findlib.git
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/findlib.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/findlib.git
 Homepage: http://projects.camlcity.org/projects/findlib.html
 
 Package: ocaml-findlib

=== debian/rules ===
--- 
+++ 
@@ -53,6 +53,5 @@
 override_dh_auto_clean:
 	if [ -f Makefile.config ]; then $(MAKE) clean; fi
 	-find . -name META -delete
-	-rm -f src/findlib/depend src/findlib/fl_metascanner.ml
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
 	-rm -Rf site-lib-src/camlp4/

## findlib 1.4.1

=== debian/changelog ===
findlib (1.4.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Mar 2014 07:46:08 +0100
